"""WAeUP portal certificates
"""
import grok
from zope.component.interfaces import IFactory
from waeup.interfaces import ICertificate, ICertificateContainer

class Certificate(grok.Container):
    """A certificate.
    """
    grok.implements(ICertificate)

    def __init__(self, code=u'NA', title=u'Unnamed Certificate',
                 category=None, study_mode=None, start_level=None,
                 end_level=None, application_category=None, m_prefix=u'',
                 max_pass = u''):
        self.code = code
        self.title = title
        self.category = category
        self.study_mode = study_mode
        self.start_level = start_level
        self.end_level = end_level
        self.application_category = application_category
        self.m_prefix = m_prefix
        self.max_pass = max_pass

class CertificateFactory(grok.GlobalUtility):
    """A factory for certificates.
    """
    grok.implements(IFactory)
    grok.name(u'waeup.Certificate')
    title = u"Create a new certificate.",
    description = u"This factory instantiates new certificate instances."

    def __call__(self):
        return Certificate()

    def getInterfaces(self):
        return implementedBy(Certificate)
